diff --git a/m4/ax_ext.m4 b/m4/ax_ext.m4
index 09c7bf2..56e54e9 100644
--- a/m4/ax_ext.m4
+++ b/m4/ax_ext.m4
@@ -10,7 +10,7 @@
 #
 #   Find supported SIMD extensions by requesting cpuid. When an SIMD
 #   extension is found, the -m"simdextensionname" is added to SIMD_FLAGS if
-#   compilator supports it. For example, if "sse2" is available, then
+#   compiler supports it. For example, if "sse2" is available, then
 #   "-msse2" is added to SIMD_FLAGS.
 #
 #   This macro calls:
@@ -24,13 +24,14 @@
 # LICENSE
 #
 #   Copyright (c) 2007 Christophe Tournayre <turn3r@users.sourceforge.net>
+#   Copyright (c) 2013 Michael Petch <mpetch@capp-sysware.com>, <mpetch@gnubg.org>
 #
 #   Copying and distribution of this file, with or without modification, are
 #   permitted in any medium without royalty provided the copyright notice
 #   and this notice are preserved. This file is offered as-is, without any
 #   warranty.
 
-#serial 11
+#serial 12
 
 AC_DEFUN([AX_EXT],
 [
@@ -57,6 +58,7 @@ AC_DEFUN([AX_EXT],
     i[[3456]]86*|x86_64*|amd64*)
 
       AC_REQUIRE([AX_GCC_X86_CPUID])
+      AC_REQUIRE([AX_GCC_X86_AVX_XGETBV])
 
       AX_GCC_X86_CPUID(0x00000001)
       ecx=`echo $ax_cv_gcc_x86_cpuid_0x00000001 | cut -d ":" -f 3`
@@ -118,21 +120,44 @@ AC_DEFUN([AX_EXT],
         fi
       ])
 
-      AC_CACHE_CHECK([whether avx is supported], [ax_cv_have_avx_ext],
+      AC_CACHE_CHECK([whether avx is supported by processor], [ax_cv_have_avx_cpu_ext],
       [
-        ax_cv_have_avx_ext=no
+        ax_cv_have_avx_cpu_ext=no
         if test "$((0x$ecx>>28&0x01))" = 1; then
-          ax_cv_have_avx_ext=yes
+          ax_cv_have_avx_cpu_ext=yes
         fi
       ])
 
+      if test x"$ax_cv_have_avx_cpu_ext" = x"yes"; then
+        AX_GCC_X86_AVX_XGETBV(0x00000000)
+
+        xgetbv_eax="0"
+        if test x"$ax_cv_gcc_x86_avx_xgetbv_0x00000000" != x"unknown"; then
+          xgetbv_eax=`echo $ax_cv_gcc_x86_avx_xgetbv_0x00000000 | cut -d ":" -f 1`
+        fi
+
+        AC_CACHE_CHECK([whether avx is supported by operating system], [ax_cv_have_avx_ext],
+        [
+          ax_cv_have_avx_ext=no
+
+          if test "$((0x$ecx>>27&0x01))" = 1; then
+            if test "$((0x$xgetbv_eax&0x6))" = 6; then
+              ax_cv_have_avx_ext=yes
+            fi
+          fi
+        ])
+        if test x"$ax_cv_have_avx_ext" = x"no"; then
+          AC_MSG_WARN([Your processor supports AVX, but your operating system doesn't])
+        fi
+      fi
+
       if test "$ax_cv_have_mmx_ext" = yes; then
         AX_CHECK_COMPILE_FLAG(-mmmx, ax_cv_support_mmx_ext=yes, [])
         if test x"$ax_cv_support_mmx_ext" = x"yes"; then
           SIMD_FLAGS="$SIMD_FLAGS -mmmx"
           AC_DEFINE(HAVE_MMX,,[Support mmx instructions])
         else
-          AC_MSG_WARN([Your processor support mmx instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports mmx instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -142,7 +167,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -msse"
           AC_DEFINE(HAVE_SSE,,[Support SSE (Streaming SIMD Extensions) instructions])
         else
-          AC_MSG_WARN([Your processor support sse instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports sse instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -152,7 +177,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -msse2"
           AC_DEFINE(HAVE_SSE2,,[Support SSE2 (Streaming SIMD Extensions 2) instructions])
         else
-          AC_MSG_WARN([Your processor support sse2 instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports sse2 instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -162,7 +187,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -msse3"
           AC_DEFINE(HAVE_SSE3,,[Support SSE3 (Streaming SIMD Extensions 3) instructions])
         else
-          AC_MSG_WARN([Your processor support sse3 instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports sse3 instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -172,7 +197,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -mssse3"
           AC_DEFINE(HAVE_SSSE3,,[Support SSSE3 (Supplemental Streaming SIMD Extensions 3) instructions])
         else
-          AC_MSG_WARN([Your processor support ssse3 instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports ssse3 instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -182,7 +207,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -msse4.1"
           AC_DEFINE(HAVE_SSE4_1,,[Support SSSE4.1 (Streaming SIMD Extensions 4.1) instructions])
         else
-          AC_MSG_WARN([Your processor support sse4.1 instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports sse4.1 instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -192,7 +217,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -msse4.2"
           AC_DEFINE(HAVE_SSE4_2,,[Support SSSE4.2 (Streaming SIMD Extensions 4.2) instructions])
         else
-          AC_MSG_WARN([Your processor support sse4.2 instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports sse4.2 instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
@@ -202,7 +227,7 @@ AC_DEFUN([AX_EXT],
           SIMD_FLAGS="$SIMD_FLAGS -mavx"
           AC_DEFINE(HAVE_AVX,,[Support AVX (Advanced Vector Extensions) instructions])
         else
-          AC_MSG_WARN([Your processor support avx instructions but not your compilor, can you try another compilor ?])
+          AC_MSG_WARN([Your processor supports avx instructions but not your compiler, can you try another compiler?])
         fi
       fi
 
diff --git a/m4/ax_gcc_x86_avx_xgetbv.m4 b/m4/ax_gcc_x86_avx_xgetbv.m4
new file mode 100644
index 0000000..7031abe
--- /dev/null
+++ b/m4/ax_gcc_x86_avx_xgetbv.m4
@@ -0,0 +1,77 @@
+#
+# SYNOPSIS
+#
+#   AX_GCC_X86_AVX_XGETBV
+#
+# DESCRIPTION
+#
+#   On later x86 processors with AVX SIMD support, with gcc or a compiler 
+#   that has a compatible syntax for inline assembly instructions, run a 
+#   small program that executes the xgetbv instruction with input OP. This
+#   can be used to detect if the OS supports AVX instruction usage.
+#
+#   On output, the values of the eax and edx registers are stored
+#   as hexadecimal strings as "eax:edx" in the cache variable
+#   ax_cv_gcc_x86_avx_xgetbv.
+#
+#   If the xgetbv instruction fails (because you are running a
+#   cross-compiler, or because you are not using gcc, or because you are on
+#   a processor that doesn't have this instruction), 
+#   ax_cv_gcc_x86_avx_xgetbv_OP is set to the string "unknown".
+#
+#   This macro mainly exists to be used in AX_EXT.
+#
+# LICENSE
+#
+#   Copyright (c) 2013 Michael Petch <mpetch@capp-sysware.com>
+#                                    <mpetch@gnubg.org>
+#
+#   This program is free software: you can redistribute it and/or modify it
+#   under the terms of the GNU General Public License as published by the
+#   Free Software Foundation, either version 3 of the License, or (at your
+#   option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+#   Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License along
+#   with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+#   As a special exception, the respective Autoconf Macro's copyright owner
+#   gives unlimited permission to copy, distribute and modify the configure
+#   scripts that are the output of Autoconf when processing the Macro. You
+#   need not follow the terms of the GNU General Public License when using
+#   or distributing such scripts, even though portions of the text of the
+#   Macro appear in them. The GNU General Public License (GPL) does govern
+#   all other use of the material that constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the Autoconf
+#   Macro released by the Autoconf Archive. When you make and distribute a
+#   modified version of the Autoconf Macro, you may extend this special
+#   exception to the GPL to apply to your modified version as well.
+
+#serial 1
+
+AC_DEFUN([AX_GCC_X86_AVX_XGETBV],
+[AC_REQUIRE([AC_PROG_CC])
+AC_LANG_PUSH([C])
+AC_CACHE_CHECK(for x86-AVX xgetbv $1 output, ax_cv_gcc_x86_avx_xgetbv_$1,
+ [AC_RUN_IFELSE([AC_LANG_PROGRAM([#include <stdio.h>], [
+     int op = $1, eax, edx;
+     FILE *f;
+      /* Opcodes for xgetbv */
+      __asm__(".byte 0x0f, 0x01, 0xd0"
+        : "=a" (eax), "=d" (edx)
+        : "c" (op));
+     f = fopen("conftest_xgetbv", "w"); if (!f) return 1;
+     fprintf(f, "%x:%x\n", eax, edx);
+     fclose(f);
+     return 0;
+])],
+     [ax_cv_gcc_x86_avx_xgetbv_$1=`cat conftest_xgetbv`; rm -f conftest_xgetbv],
+     [ax_cv_gcc_x86_avx_xgetbv_$1=unknown; rm -f conftest_xgetbv],
+     [ax_cv_gcc_x86_avx_xgetbv_$1=unknown])])
+AC_LANG_POP([C])
+])
-- 
1.7.10.4